/* glance.c - generate a "gopher tree at a glance" file from walker output */
/* Bruce Tanner -- Cerritos College */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

struct {
    char type;
    char *value;
} graphics[] = {{'0',""},{'1',"/"},{'2'," <CSO>"},{'4'," <HQX>"},
                {'5'," <PC Bin>"},{'7'," <?>"},{'8'," <TEL>"},
                {'9'," <Bin>"},{'I'," <Picture>"},{'T'," <3270>"},
                {'s'," <)"},{'g'," <Picture>"},{'M'," <MIME>"},
                {'h'," <HTML>"},{';'," <Movie>"},{'\0', ""}};

char *get_graphic(char);

main(int argc, char *argv[])
{
    char *cp, in_line[500], prefix[200], title[500];
    int level;
    FILE *in, *out;

    if (argc != 3) {
        printf("usage: glance input output\n");
        exit(1);
    }

    if ((in = fopen(argv[1], "r")) == NULL) {
        perror("open input");
        exit(1);
    }
    
    if ((out = fopen(argv[2], "w")) == NULL) {
        perror("open output");
        exit(1);
    }

    while (fgets(in_line, sizeof(in_line), in)) {
        if (cp = strchr(in_line, '\n'))
            *cp = '\0';                                 /* remove newline */
        if (strncmp(in_line, "Title: ", 7) == 0) {      /* Title line? */
            strcpy(title, in_line + 10);                /* yes, save it */
            level = atoi(in_line + 7);                  /* get level */
        }
        if (strncmp(in_line, "Selector: ", 10) == 0) {  /* Selector line? */
            prefix[0] = '\0';
            while (level) {                             /* prefix the level */
                strcat(prefix, "| ");
                level--;
            }
            fprintf(out, "%s%s%s\n", prefix, title, get_graphic(in_line[10]));
        }
    }
    fclose(in);
    fclose(out);
}


char *get_graphic(char ch)
{
    int ind;

    for (ind = 0; graphics[ind].type; ind++)
        if (graphics[ind].type == ch)
            return graphics[ind].value;
    return "";
}
